import time

import pygtk
pygtk.require('2.0')
import gobject
import pango
import gtk
import scw


def entry_activated(entry, model):
  iter = model.append()
  model.set(iter,
            0, time.time(),
            1, "[<action id='testID'><b>testuser</b></action>]",
            3, entry.get_text())
  entry.set_text("")

def on_view_activated(view, action_id, action_data, model):
  print "Activated id %s which has data %s" % (action_id, action_data)
  view.scroll_to_row ("1")

# TODO: Show a menu
def on_context_request(view, action_id, action_data, x, y, model):
  if action_id is not None:
    print "Context request at (%i,%i) for id %s which has data %s" % \
          (x, y, action_id, action_data)
  else:
    print "Context request at (%i,%i) for global context menu" % (x,y)
  
gtk.rc_parse_string("style \"test\""
                    "{"
                    "ScwView::alternate-row-colors = 1 "
                    "ScwView::even-row-color = \"#ffffff\" "
                    "ScwView::odd-row-color = \"#dddddd\" "
                    "ScwView::odd-row-tint = 0.5 "
                    "ScwView::column-spacing = 12 "
                    "ScwView::row-padding = 6 "
                    "text[ACTIVE] = \"#ffeeff\" "
                    "text[SELECTED] = \"#ffeeff\" "
                    "text[PRELIGHT] = \"#ff99ee\" "
                    "}\n"
                    "widget \"*.ScwView\" style \"test\"")

win = gtk.Window()

win.connect("delete-event", gtk.main_quit)

win.set_size_request(400, 300)

box = gtk.VBox(False, 6)

win.add(box)

swin = gtk.ScrolledWindow (None, None)

swin.set_policy (gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)

box.add(swin)


model = gtk.ListStore(scw.TYPE_TIMESTAMP,
                      scw.TYPE_PRESENCE,
                      gtk.gdk.Pixbuf,
                      gobject.TYPE_STRING,
                      scw.TYPE_ROW_COLOR)

view = scw.View()

view.connect("activate", on_view_activated, model)
view.connect("context-request", on_context_request, model)

view.set_property("model", model)
view.set_property("align-presences", True)
view.set_property("presence-alignment", pango.ALIGN_CENTER)
view.set_property("scroll-on-append", True)
view.set_property("timestamp-format", "%H/%M")
view.set_property("action-attributes", "underline='single' weight='bold'")
view.set_property("selection-row-separator", "\n\n")
view.set_property("selection-column-separator", "\t")
view.set_property("embedded-icon-size", 24)
view.set_property("interaction", scw.INTERACTION_SMART_PAN)

iter = model.append()
model.set(iter,
          0, time.time(),
          1, "[<b><action id='zuhID'>zuh</action></b>]",
          2, gtk.gdk.pixbuf_new_from_file_at_size("scw.png", 24, 24),
          3, "<big><i><b>Welcome to Scw</b></i></big>",
          4, "#ffbbee")

iter = model.append()
model.set(iter,
          0, time.time(),
          1, "[<b><action id='zuhID'>zuh</action></b>]",
          2, gtk.gdk.pixbuf_new_from_file_at_size("scw.png", 24, 24),
          3, "Home page of <b>Scw</b> is at "
             "<icon id='gtk-home'><action id='url'>http://iki.fi/zuh/scw/</action>")

view.set_column_foldable (1, True)
view.set_column_foldable (2, True)
view.scroll_to_end()

swin.add(view)

entry = scw.Entry()

entry.connect("activate", entry_activated, model)

entry.set_property("history-size", 100)

box.pack_end(entry, False, True, 0)

# TODO: The view methods

win.show_all()


gtk.main ()
